#ifndef MADCALC_H
#define MADCALC_H
#include "QMainWindow"
//Далее инклюды для keyBinding
#include "QWidget"
#include "QGridLayout"
#include "QKeyEvent"
#include "QDialog"

#include <QTcpSocket>


//инклюды форм
#include "newmadcalc.h"
#include "prog.h"
#include "about.h"
#include "madupdate.h"

#include <QCloseEvent>


//далее про структуру программы в целом
QT_BEGIN_NAMESPACE
namespace Ui { class madCalc; }
QT_END_NAMESPACE

class madCalc : public QMainWindow
{
    Q_OBJECT

public:
    madCalc(QWidget *parent = nullptr);
    ~madCalc();

    QByteArray buffer;     //TCP буфер для приема версии madCalc с сервера автообновления
    QString version = "2.3";  //Версия программы madCalc
    void abortOperation(); //Объявляем функцию отмены операции (в связи с ошибкой)
    void StatusBar(); //Объявляем функцию статус-бара, чтобы выводить туда сообщение. В этом случае там будет про сумму, записанную в памяти.
    bool calculate (double rightOperand, const QString &pendingOperator);
    double sumInMemory = 0.0; //Переменная для реализации кнопок управления памятью.
    double num = 0.0;         //Переменная для хранения первого операнда
    QString pendingAdditiveOperator; //Содержит знак выполняемого оператора
    QString pendingMultiplicativeOperator; //Аналогично для мутипликативных операторов
    //на самом деле, наверно, для этих целей нет смысла создавать два отдельных класса, а то получается какая-то нелепая куча говнокода,
    //но у нас учебная программа, поэтому сойдет и так
    bool waitingForOperand; //переменная двоичного типа (false или true) для того чтобы определиться, ждем мы следующего операнда или нет
    QString clickedOperator;
    double PER; //Вот эта переменная нужна для функции void Percent(); чтобы вычислять проценты
    double digitValue;
    QString LCD2;
    QString upState;


private:
    Ui::madCalc  *ui;
    about *formAbout;
    madUpdate *mUpdate;
    QTcpSocket *socket;


    void closeEvent(QCloseEvent *event);

protected:
   virtual void keyPressEvent(QKeyEvent *event); //Здесь заканчивается конструкция которая позволяет вводить цифры с клавиатуры


//Здесь мои слоты
public slots:
    void updateCheck();
    void digitClicked();           //Обработчик нажатия цифровых кнопок из GUI
    void unaryOperatorClicked();   //Унарные операторы
    void root();                   //Вычисление корня
    void additiveOperator();       // Операторы сложения/вычитания
    void multiplicativeOperator(); // Операторы умножения/деления
    void equalClicked();           //Функция знака =
    void btnDot();                 //Это если нажать "точку" Dot(".")
    void funcPM();                 //Умножает число на lcd1 на -1, нужно для кнопки +/-
    void Backspase();              //Функция удаления последнего знака
    void Operator();               //Приемник для кнопок операторов, ловит их значение и передает далее по структуре.
    void OperatorSender();         // Сюда. Это нужно чтобы подключить клавиатуру
    void Digit();                  //Обработчик нажатия всех кнопок, как с GUI так и с клавиатуры
    void Percent();                //Объявляем функцию вычисления процентов
    void CE();                     //Функция сброса текущего операнда
    void ClearAll();               //Функция сброса вычислений
    void About();                  //Функция вызова формы about
    //Блок управления памятью
    void setMemory();              //Записать в память
    void clearMemory();            //Очистить память
    void readMemory();             //Прочесть память и вывести на экран
    void subtMemory();             //Вычесть из числа в памяти число с экрана
    void addToMemory();            //Прибавить к записанному в памяти числу содержимое экрана lcd1
    void En();                     //Кнопка переключения режима на инженерный
    void Prog();                   //Режим программиста
    void socket_Read_Data();       //Чтение из TCP сокета
    void socket_Disconnected();    //Отключение от сокета?
    void moveToCenter();           //Выравниваем окно по центру экрана
    void updateState(QString uState); //Здесь мы разбираемся, открывалось ли окошко обновления или нет
    void update();



signals:
    void signalVersion(QString);



};
#endif // MADCALC_H
