#include "madupdate.h"
#include "ui_madupdate.h"
#include <QDesktopWidget>
#include <QProcess>
#include "madcalc.h"

madUpdate::madUpdate(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::madUpdate)
{
    ui->setupUi(this);
    //madcalc = new madCalc;
    setWindowModality(Qt::ApplicationModal);
    setWindowFlags(Qt::Dialog | Qt::MSWindowsFixedSizeDialogHint);
    setWindowFlags(Qt::WindowStaysOnTopHint);
    setWindowFlags(Qt::Dialog | Qt::MSWindowsFixedSizeDialogHint); //Данная строчка запрещает изменение размеров окна
    connect(ui->btnOk, SIGNAL(clicked()), this, SLOT(Warning()));
    connect(ui->btnNo, SIGNAL(clicked()), this, SLOT(Warning()));
}

madUpdate::~madUpdate()
{
    delete ui;
}

void madUpdate::moveToCenter()
{
    QRect rect = frameGeometry();
    rect.moveCenter(QDesktopWidget().availableGeometry().center());
    move(rect.topLeft());
}

void madUpdate::update()
{
     emit updateState("Yes");
     this->close();
}

void madUpdate::versionResieve(QString vers)
{
    QString text = "Внимание! Вышла новая версия - madCalc" + vers + "! Установить ее прямо сейчас или как-нибудь после дождичка в четверг?!";
    ui->warning->setText(text);
    ui->warning->setAlignment(Qt::AlignJustify);
}

void madUpdate::Warning()
{
    QPushButton *button = (QPushButton *)sender();
    QString buttonValue = button->text();
    if (buttonValue == "Установить!"){
        update();
        //QApplication::quit();
    }
    else {
        this->hide();
        qDebug() << "Установка обновления отменена пользователем.";
         }
}
