﻿#include "newmadcalc.h"
#include "madcalc.h"
#include "ui_newmadcalc.h"
#include "prog.h"
#include "QDesktopWidget"
#include "about.h"
#include "global.h"
#include "qmath.h" //Библиотека для поддержки математических операций, таких как sqrt и pow

#include "QDialog"
#include "button.h"


newmadcalc::newmadcalc(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::newmadcalc)
{
    setWindowFlags(Qt::Dialog | Qt::MSWindowsFixedSizeDialogHint); //Данная строчка запрещает изменение размеров окна
    ui->setupUi(this);
    formAbout = new about;

    //Далее подключаем цифровые кнопки
    connect(ui->btn0, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn1, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn2, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn3, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn4, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn5, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn6, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn7, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn8, SIGNAL(clicked()), this, SLOT(digitClicked()));
    connect(ui->btn9, SIGNAL(clicked()), this, SLOT(digitClicked()));

    //Вычисление корня
    connect(ui->btnRoot, SIGNAL(clicked()), this, SLOT(root()));  //Кнопка для вычисления корня

    //Кнопки унарных операций
    connect(ui->btn1x,   SIGNAL(clicked()),  this,  SLOT(unaryOperatorClicked()));  //Кнопка btn1x вычисляет 1/x
    connect(ui->btnLn,   SIGNAL(clicked()),  this,  SLOT(unaryOperatorClicked()));  //натуральный логарифм
    //connect(ui->btnLog,  SIGNAL(clicked()),  this,  SLOT(unaryOperatorClicked()));  //Десятичный логарифм
    connect(ui->btnX2,   SIGNAL(clicked()),  this,  SLOT(unaryOperatorClicked()));  //Возведение в квадрат
    connect(ui->btnFact, SIGNAL(clicked()),  this,  SLOT(unaryOperatorClicked()));

    //Мультипликативные операции
    connect(ui->btnDivide,   SIGNAL(clicked()), this, SLOT(Operator())); //Деление
    connect(ui->btnMultiply, SIGNAL(clicked()), this, SLOT(Operator())); //Умножение
    connect(ui->btnPlus,     SIGNAL(clicked()), this, SLOT(Operator())); //Сложение
    connect(ui->btnMinus,    SIGNAL(clicked()), this, SLOT(Operator())); //Вычитание
    connect(ui->btnX2,       SIGNAL(clicked()), this, SLOT(Exponentiation())); //Возведение в степень
    connect(ui->btnLog,      SIGNAL(clicked()), this, SLOT(Log())); //Логарифм x по основанию a

    //Кнопка +/-
    connect(ui->btnPM, SIGNAL(clicked()), this, SLOT(funcPM()));

    //Кнопки сброса
    connect(ui->btnC, SIGNAL(clicked()),  this, SLOT(ClearAll())); //Кнопка С
    connect(ui->btnCE, SIGNAL(clicked()), this, SLOT(CE()));//Кнопка CE

    //Кнопка "." для цифрового ввода
    connect(ui->btnDot, SIGNAL(clicked()), this, SLOT(btnDot()));

    //Кнопка которая удалет последний знак в строке lcd1
    connect(ui->btnBackspace, SIGNAL(clicked()), this, SLOT(Backspase()));

    //Кнопка =
    connect(ui->btnEqual, SIGNAL(clicked()), this, SLOT(equalClicked()));

    //Кнопки управления памятью
    connect(ui->btnMC, SIGNAL(clicked()),   this,  SLOT(clearMemory()));
    connect(ui->btnMR, SIGNAL(clicked()),   this,  SLOT(readMemory()));
    connect(ui->btnMP, SIGNAL(clicked()),   this,  SLOT(addToMemory()));
    connect(ui->btnMM, SIGNAL(clicked()),   this,  SLOT(subtMemory()));
    connect(ui->btnMS, SIGNAL(clicked()),   this,  SLOT(setMemory()));

    //Кнопка вычисления процентов
    connect(ui->btnPer, SIGNAL(clicked()),  this,  SLOT(Percent()));

    //Кнопка вызова формы About
    connect(ui->btnAb, SIGNAL(clicked()),   this,  SLOT(About()));

    //Кнопка вызова второй формы
    connect(ui->btnProg, SIGNAL(clicked()), this,  SLOT(Prog()));  //Кнопка вызова режима программиста
    connect(ui->btnMain, SIGNAL(clicked()), this,  SLOT(Main()));  //Кнопка основного режима

    //
    connect(ui->btnGrade, SIGNAL(clicked()), this, SLOT(Grade()));
    connect(ui->btnShift, SIGNAL(clicked()), this, SLOT(Shift()));


    //Кнопка числа пи
    connect(ui->btnPi, SIGNAL(clicked()), this, SLOT(_Pi_()));

    //Тригонометрические функции
    connect(ui->btnSin, SIGNAL(clicked()), this, SLOT(unaryOperatorClicked()));
    connect(ui->btnCos, SIGNAL(clicked()), this, SLOT(unaryOperatorClicked()));
    connect(ui->btnTg,  SIGNAL(clicked()), this, SLOT(unaryOperatorClicked()));
    connect(ui->btnCtg, SIGNAL(clicked()), this, SLOT(unaryOperatorClicked()));

    //Радиобатоны для установки угловой меры
    connect(ui->rb1, SIGNAL(clicked()), this, SLOT(rbGrade()));
    connect(ui->rb2, SIGNAL(clicked()), this, SLOT(rbGrade()));
    connect(ui->rb3, SIGNAL(clicked()), this, SLOT(rbGrade()));

     //Здесь довольно сложная конструкция статус бара. Он состоит из двух QLabel, которые перекрывают друг друга, в каждом свое выравнивание
         ui->status1->setStyleSheet(
         "QLabel{background-color: rgba(255, 255, 255, 0);}"
         "qproperty-alignment: 'AlignVCenter | AlignLeft';"
         );
         ui->status2->setStyleSheet(
         "QLabel{background-color: rgba(255, 255, 255, 0);"
         "qproperty-alignment: 'AlignVCenter | AlignRight';"
         "color: black;"
         "border: 1px solid gray;"
         "}"
         );
     ui->status1->setText(" madmentat.ru");
     ui->status2->setText("Для справки нажмите F1");

     //Это нижний экран, на всякий случай
     ui->lcd3->setText("");

     moveToCenter();
     ui->lcd3->setText("");
     waitingForOperand = true;
     ui->rb1->setChecked(true);

//Всплывающие подсказки (ToolTips)
     //Ординарные
     ui->btnAb->setToolTip ("Информация о программе, горячая клавиша F1");
     ui->btnMC->setToolTip("Сбросить число в памяти.");
     ui->btnMR->setToolTip("Вывести на экран число из памяти.");
     ui->btnMS->setToolTip("Записать число в память.");
     ui->btnMP->setToolTip("Прибавить к числу в памяти число с экрана.");
     ui->btnMM->setToolTip("Отнять от числа в памяти число с экрана.");
     ui->btnGrade->setToolTip("Изменить угловую меру.");
     ui->btnMain->setToolTip("Перейти в обычный режим.");
     ui->btnC->setToolTip("Кнопка сброса.");
     ui->btnCE->setToolTip("Сбросить крайнее действие.");
     ui->btnShift->setToolTip("Кнопка для открытия дополнительных фунций.");
     ui->btnBackspace->setToolTip("Убрать крайний знак справа.");
     ui->btnPi->setToolTip("Вывести на экран чило Pi.");
     ui->btnFact->setToolTip("Вычислить факториал.");
     ui->btnEqual->setToolTip("Вывести результат на экран");

     //Экстраординарные
     ui->btnLn->setToolTip("Вычислить линейный логарифм.");
     ui->btnSin->setToolTip("Вычисление синуса.");
     ui->btnCos->setToolTip("Вычисление косинуса.");
     ui->btnTg->setToolTip("Вычисление тангенса.");
     ui->btnCtg->setToolTip("Вычисление котангенса.");
     ui->btn1x->setToolTip("Вычисление одной части от x.");
     ui->btnX2->setToolTip("Вычисление квадрата x.");
     ui->btnPer->setToolTip("Вычисление процента.");
     ui->btnRoot->setToolTip("Вычисление квадратного корня от x.");
     ui->btnLog->setToolTip("Вычислить логарифм x по основанию a.");

     //Тултипы радиобатонов
     ui->rb1->setToolTip("Градус. 1/90 часть прямого угла.");
     ui->rb2->setToolTip("Радиан. Угол, соответствующий дуге, длина которой равна её радиусу.");
     ui->rb3->setToolTip("Град. Метрический градус. Одна сотая часть прямого угла.");

}


void newmadcalc::_Pi_()
{
    QString valuePi = QString::number(Pi);
    ui->lcd1->setText(valuePi);
}

void newmadcalc::Shift()
{
    if (ui->btnShift->text().contains("↓")){

        QString YellowStyle; //чтобы не писать стиль для каждой кнопки отдельно, создадим кустринг, куда запишем образец дополнительного стиля
        YellowStyle = (
                    "QPushButton { background-color: yellow; color: black; border: 1px solid gray}"
                    "QPushButton:hover {background-color: rgb(225, 225, 0);}"
                    "QPushButton:pressed {background-color: qlineargradient(x1:0, y1:0, x2:0, y2:0, stop: 0 #FF7832, stop 1 #FF9739)}"
                    );

        QString GreenStyle;
        GreenStyle = (
                    "QPushButton {background-color: rgb(20, 220, 20); color: black; border: 1px solid gray}"
                    "QPushButton:hover {background-color: rgb(20, 180, 0);}"
                    "QPushButton:pressed {color: black; background-color: qlineargradient(x1:0, y1:0, x2:0, y2:0, stop: 0 #FF7832, stop 1 #FF9739)}"
                    );

        ui->btnShift->setStyleSheet(YellowStyle); //Задаем стиль, взятый из нашего кустринга
        ui->btnShift->setText("Shift ↑"); //Задаем текст на кнопке

        ui->btnSin->setStyleSheet(GreenStyle);
        ui->btnSin->setText("arcsin");

        ui->btnCos->setStyleSheet(GreenStyle);
        ui->btnCos->setText("arccos");

        ui->btnTg->setStyleSheet(GreenStyle);
        ui->btnTg->setText("arctg");

        ui->btnCtg->setStyleSheet(GreenStyle);
        ui->btnCtg->setText("arcctg");

        ui->btnX2->setStyleSheet(GreenStyle);
        ui->btnX2->setText("xʸ");

        ui->btn1x->setStyleSheet(GreenStyle);
        ui->btn1x->setText("expˣ");

        ui->btnPer->setStyleSheet(GreenStyle);
        ui->btnPer->setText("y%(x)");

        ui->btnX2->setStyleSheet(GreenStyle);
        ui->btnX2->setText("xʸ");

        ui->btnRoot->setStyleSheet(GreenStyle);
        ui->btnRoot->setText("ⁿ√x");

        ui->btnLog->setStyleSheet(GreenStyle);
        ui->btnLog->setText("lg");

        //Всплывающие подсказки экстраординарные
        ui->btnSin->setToolTip("Вычисление арксинуса.");
        ui->btnCos->setToolTip("Вычисление арккосинуса.");
        ui->btnTg->setToolTip("Вычисление арктангенса.");
        ui->btnCtg->setToolTip("Вычисление арккотангенса.");
        ui->btn1x->setToolTip("Вычисление экспоненты.");
        ui->btnX2->setToolTip("Вычисление x  в степени y.");
        ui->btnPer->setToolTip("Вычисление y процентов от x.");
        ui->btnRoot->setToolTip("Вычисление крня n степени от x.");
        ui->btnLog->setToolTip("Вычислить десятичный логарифм.");

        ShiftState=true;
    }
    else {

        QString NormStyle; //чтобы не писать стиль для каждой кнопки отдельно, создадим кустринг, куда запишем образец нормального стиля
        NormStyle = (
                    "QPushButton {background-color: rgb(255, 151, 57); color: white; border: 1px solid gray}"
                    "QPushButton:hover {background-color: rgb(220, 130, 50);}"
                    "QPushButton:pressed {color: black; background-color: qlineargradient(x1:0, y1:0, x2:0, y2:0, stop: 0 #FF7832, stop 1 #FF9739)}"
                    );

        ui->btnShift->setStyleSheet(NormStyle);
        ui->btnShift->setText("Shift ↓");

        ui->btnSin->setStyleSheet(NormStyle);
        ui->btnSin->setText("sin");

        ui->btnCos->setStyleSheet(NormStyle);
        ui->btnCos->setText("cos");

        ui->btnTg->setStyleSheet(NormStyle);
        ui->btnTg->setText("tg");

        ui->btnCtg->setStyleSheet(NormStyle);
        ui->btnCtg->setText("ctg");


        ui->btnX2->setStyleSheet(NormStyle);
        ui->btnX2->setText("x²");

        ui->btn1x->setStyleSheet(NormStyle);
        ui->btn1x->setText("1/x");

        ui->btnPer->setStyleSheet(NormStyle);
        ui->btnPer->setText("%");

        ui->btnRoot->setStyleSheet(NormStyle);
        ui->btnRoot->setText("²√x");

        ui->btnLog->setStyleSheet(NormStyle);
        ui->btnLog->setText("logₐx");

        //ординрные, чтобы вернуть на место
        ui->btnAb->setToolTip ("Информация о программе, горячая клавиша F1");
        ui->btnMC->setToolTip("Сбросить число в памяти.");
        ui->btnMR->setToolTip("Вывести на экран число из памяти.");
        ui->btnMS->setToolTip("Записать число в память.");
        ui->btnMP->setToolTip("Прибавить к числу в памяти число с экрана.");
        ui->btnMM->setToolTip("Отнять от числа в памяти число с экрана.");
        ui->btnGrade->setToolTip("Изменить угловую меру.");
        ui->btnMain->setToolTip("Перейти в обычный режим.");
        ui->btnC->setToolTip("Кнопка сброса.");
        ui->btnCE->setToolTip("Сбросить крайнее действие.");
        ui->btnShift->setToolTip("Кнопка для открытия дополнительных фунций.");
        ui->btnBackspace->setToolTip("Убрать крайний знак справа.");
        ui->btnPi->setToolTip("Вывести на экран чило Pi.");
        ui->btnFact->setToolTip("Вычислить факториал.");
        ui->btnLog->setToolTip("Вычислить логарифм x по основанию a.");
        ui->btnLn->setToolTip("Вычислить линейный логарифм.");
        ui->btnSin->setToolTip("Вычисление синуса.");
        ui->btnCos->setToolTip("Вычисление косинуса.");
        ui->btnTg->setToolTip("Вычисление тангенса.");
        ui->btnCtg->setToolTip("Вычисление котангенса.");
        ui->btn1x->setToolTip("Вычисление одной части от x.");
        ui->btnX2->setToolTip("Вычисление квадрата x.");
        ui->btnPer->setToolTip("Вычисление процента.");
        ui->btnRoot->setToolTip("Вычисление квадратного корня от x.");
        ShiftState=false;
    }
}



newmadcalc::~newmadcalc()
{
    delete ui;
}

void newmadcalc::moveToCenter(){
    QRect rect = frameGeometry();
    rect.moveCenter(QDesktopWidget().availableGeometry().center());
    move(rect.topLeft());
}


//вычисляем факториал
long double fact(int N)
{
    if(N < 0) // если пользователь ввел отрицательное число
        return 0; // возвращаем ноль
    if (N == 0) // если пользователь ввел ноль,
        return 1; // возвращаем факториал от нуля - не удивляетесь, но это 1 =)
    else // Во всех остальных случаях
        return N * fact(N - 1); // делаем рекурсию.
}


void newmadcalc::Main()
{
    this->hide();
    madCalc *frm = new madCalc();
                     frm->show();
                     formAbout->close();
}

void newmadcalc::Prog()
{
    this->hide();
    prog *frm = new prog();
               frm->show();
}

void newmadcalc::Grade()
{
    if      (ui->btnGrade->text()=="Deg"){ui->btnGrade->setText("Rad"); ui->rb2->setChecked(true); ui->rb1->setChecked(false); ui->rb3->setChecked(false); GradeState="Rad";}
    else if (ui->btnGrade->text()=="Rad"){ui->btnGrade->setText("Gon"); ui->rb3->setChecked(true); ui->rb2->setChecked(false); ui->rb1->setChecked(false); GradeState="Gon";}
    else if (ui->btnGrade->text()=="Gon"){ui->btnGrade->setText("Deg"); ui->rb1->setChecked(true); ui->rb3->setChecked(false); ui->rb1->setChecked(false); GradeState="Deg";}

}

void newmadcalc::rbGrade()
{
    if (ui->rb1->isChecked()){ui->btnGrade->setText("Deg"); ui->rb2->setChecked(false); ui->rb3->setChecked(false); GradeState="Deg";}
    if (ui->rb2->isChecked()){ui->btnGrade->setText("Rad"); ui->rb3->setChecked(false); ui->rb1->setChecked(false); GradeState="Rad";}
    if (ui->rb3->isChecked()){ui->btnGrade->setText("Gon"); ui->rb1->setChecked(false); ui->rb2->setChecked(false); GradeState="Gon";}
}

void newmadcalc::SetTextOnLCD1()
{
    ui->lcd1->setText("fuck");
}



void newmadcalc::StatusBar()
{
    //Выводим в статус бар сообщение о содержимом памяти, но чтобы это получилось, для начала переводим double в qstring
    QString valueAsString = QString::number(sumInMemory);
    ui->status1->setText(" Число в памяти: " + valueAsString);
}


//Кнопка backspase
void newmadcalc::Backspase()
{
    double operand = ui->lcd1->text().toDouble(); //Переписываем содержимое экрана в переменную operand типа double
    if (operand == 0){                            //Если операнд на экране равен нулю, то
        ui->lcd1->setText("0");                   //Оставляем все как есть
    }
    else {                                        //В противном случае подрезаем его справа
    QString str;
    str = ui->lcd1->text();
    str.resize(str.size() - 1);                   //На единицу
    ui->lcd1->setText(str);                       //И возвращаем результат на экран
    }
    int sizeOfText = ui->lcd1->text().size();     //Здесь мы объявляем переменную sizeOfText которая принимает кол-во символов в строке
    if (sizeOfText < 1) {                         //И запускаем проверку. Если на экране остался меньше 1 символа, то
        ui->lcd1->setText("0");                   //Записываем на экран 0
    }
    waitingForOperand = false;                     //А вот без этой строчки при дальнейшем наборе циферек будет нечто типа 0123 и т. п.
}

//Блок управления памятью
//MC стирает данные из ячейки памяти.
void newmadcalc::clearMemory() {
 sumInMemory = 0.0;
    ui->status1->setText(" madmentat.ru");
    ui->status2->setText("Для справки нажмите F1");
    if (ui->lcd1->text() == "0"){waitingForOperand = true;} //Данная проверка нужна для того чтобы после нажатия кнопки избежать нуля перед числом, вроде 0123
    else waitingForOperand = false;
}
//Читает из памяти и выводит на экран
void newmadcalc::readMemory() {
 ui->lcd1->setText(QString::number(sumInMemory));
 if (ui->lcd1->text() == "0"){waitingForOperand = true;} //Данная проверка нужна для того чтобы после нажатия кнопки избежать нуля перед числом, вроде 0123
else waitingForOperand = false;
}
void newmadcalc::setMemory() {
 sumInMemory = ui->lcd1->text().toDouble();
 StatusBar();
 if (ui->lcd1->text() == "0"){waitingForOperand = true;} //Данная проверка нужна для того чтобы после нажатия кнопки избежать нуля перед числом, вроде 0123
else waitingForOperand = false;
 }

//M+ прибавляет к числу из памяти число, отображенное на дисплее и записывает результат в память вместо предыдущего
void newmadcalc::addToMemory() {
 sumInMemory += ui->lcd1->text().toDouble();
 StatusBar();
 if (ui->lcd1->text() == "0"){waitingForOperand = true;} //Данная проверка нужна для того чтобы после нажатия кнопки избежать нуля перед числом, вроде 0123
else waitingForOperand = false;
}
//MS - сохраняет в память число, отображенное на дисплее
void newmadcalc::subtMemory() {
 sumInMemory -= ui->lcd1->text().toDouble();
 StatusBar();
 if (ui->lcd1->text() == "0"){waitingForOperand = true;} //Данная проверка нужна для того чтобы после нажатия кнопки избежать нуля перед числом, вроде 0123
else waitingForOperand = false;
 }

//Функция кнопки +/-
void newmadcalc::funcPM()
{
    QPushButton *button = (QPushButton *)sender();
        double all_numbers;
        QString new_label;
        if(button->text() == "+/-"){                            //Если текст кнопки содержит "+/-", то выполняем следующее:
            all_numbers = (ui->lcd1->text().toDouble());        //Переводим содержимое lcd1 в формат Double и записываем в переменную all_numbers
            all_numbers = all_numbers * -1;                     //Умножаем all_numbers на -1
            new_label = QString::number(all_numbers, 'g', 13);  //Ограничиваем строку в 13 знаков
            ui->lcd1->setText(new_label);                       // выводим сообщение в lcd1
    }
}

//Сообщение об ошибкеикод x процентов от yикод x процентов от y в случае ошибки (например, деление на 0)
void newmadcalc::abortOperation() {
    //Обнуляем все наши переменные
    num = 0.0;
   // factorSoFar = 0.0;
    clickedOperator.clear();
    clickedOperator.clear();
    //Ждем следующего операнда
    waitingForOperand = true;
    //Выводим на экран сообщение об ошибке
    ui->lcd1->setText(tr("ERROR"));
}

//Ввод с клавиатуры
void newmadcalc::keyPressEvent(QKeyEvent *event) {
 int key=event->key();                   //event->key() - целочисленный код клавиши
 QString str = QString(QChar(key));
 if (key>=Qt::Key_0 && key<=Qt::Key_9) { //Цифровые клавиши 0..9
 digitValue = str.toDouble();
 Digit();
 }
 else if (key==Qt::Key_Backspace) { //BackSpace стирает символ
  Backspase();
 }
 else if (key==Qt::Key_Delete) { //Delete стирает всё
  ClearAll();
 }

 else if (key==Qt::Key_Plus || key==Qt::Key_Minus || key==Qt::Key_Asterisk || key==Qt::Key_Slash ) {
 clickedOperator = str;
 OperatorSender();
 }
 else if (key==Qt::Key_Enter) {
 equalClicked();
 }

 else if (key==Qt::Key_Period) {
btnDot();
 }


 else if (key==Qt::Key_Shift) {
 Shift(); //Вызов метода Shift, который открывает дополнительные кнопки вместо Sin и т. д.
 }

 else if (key==Qt::Key_F1) {
 About(); //Функция вызова формы about
 }
}

void newmadcalc::closeEvent(QCloseEvent *event)
{
    formAbout->close();
}
//Конец конструкции ввода с клавиатуры

//Данная функция принимает сигналы от кнопок из GUI а затем записывает их содержание в digitValue и вызывает метод Digit()
void newmadcalc::digitClicked() {
 QPushButton *button = (QPushButton *)sender();
 digitValue = button->text().toInt();
 Digit();
}

//Метод Digit()
void newmadcalc::Digit(){
 if (ui->lcd1->text() == "0" && digitValue == 0.0) return;
 if (waitingForOperand) {
  ui->lcd1->clear();
  waitingForOperand = false;
 }
 ui->lcd1->setText(ui->lcd1->text() + QString::number(digitValue));
}

//Актуальная конструкция для точки Dot(".")
void newmadcalc::btnDot() {
 if (waitingForOperand) ui->lcd1->setText("0");
 if (!ui->lcd1->text().contains(".")) ui->lcd1->setText(ui->lcd1->text() + tr("."));
 waitingForOperand = false;
}

//Вычисление процента
void newmadcalc::Percent()
{
    //Дебаг ui->lcd3->setText(clickedOperator);
    //В данной функции будет 2 пути с одной развилкой.
    //Первый путь, когда надпись на кнопке равна конкретно "%". Он делится на 2 варианта - либо clickedOperator пуст, либо нет
    //Второй путь, когда надпись на кнопке не равно конкретно "%"
    QPushButton *button = (QPushButton *)sender();               //Слушаем sender
    QString perButton = button->text();                          //Пишем в perButton знак, прочитанный с кнопки
    double operand = ui->lcd1->text().toDouble();                //Берем операнд c экрана
    if (perButton == "%"){                                       //Если на кнопке %, то
       if (clickedOperator.isEmpty()){                           //Вариант с пустым clickedOperator
           ui->lcd2->setText(QString::number(operand)+"%");
           num = operand;
           perState = true;

       }
       else {                                                    //Вариант с каким-то нажатым оператором
           ui->lcd2->setText(QString::number(num)+ clickedOperator + QString::number(operand) +"%"); //Пишем в lcd2 num (первый операнд), оператор и второй операнд + знак %
           PER = num*operand/100;                                // Вычисляем процент num от operand и сохраняем это в переменную PER
           ui->lcd1->setText(QString::number(PER));              // Выводим результат на экран
       }

    }
    else if (perButton == "")     {

       ui->lcd2->setText(QString::number(operand));

    }
    else if (perButton == "y%(x)"){
       num  = operand; //Записываем операнд в num
       LCD2 = QString::number(num) + "%";
       ui->lcd2->setText(LCD2);
       clickedOperator = perButton;
    }
    waitingForOperand = false;
}

void newmadcalc::Log()
{
    double result = 0.0;
    double X = ui->lcd1->text().toDouble();
    num = X;
    QPushButton *button = (QPushButton *)sender(); //Слушаем sender
    clickedOperator = button->text();
    if (clickedOperator == "logₐx"){
        ui->lcd2->setText("log<sub>a</sub>" + QString::number(num) + ", задайте a");
        waitingForOperand = true;
    }
    else {
          result = log10(num);
          ui->lcd1->setText(QString::number(result));
          num = 0;
    }
}

//Вычисление корня
void newmadcalc::root()
{
    QPushButton *button = (QPushButton *)sender(); //Слушаем sender
    clickedOperator = button->text();

if (clickedOperator == tr("²√x")){ //Если на кнопочке написано "²√x", тогда
    double operand = ui->lcd1->text().toDouble();  //Записываем в operand содержимое lcd1
    num = operand;
    double result = 0.0;            //объявляем переменную result, равную 0
    if (operand == -1){
        QString complex = "i";      //объявяем кустринг i. Это просто буквенный индекс для обозночения комплексного числа
        ui->lcd1->setText(complex); //Выводим result на экран
    }
    else if (operand < -1) {
         operand = -1 * operand;
         result = sqrt(operand);
         QString str = QString::number(result);
         QString complex = str + "i";
         ui->lcd1->setText(complex); //Выводим result на экран
     }

    else {
         result = sqrt(operand);
         QString str = QString::number(result);
         ui->lcd1->setText(str);     //Выводим result на экран
     }

    QString str = QString::number(num);
    ui->lcd2->setText("√(" + str + ") =");
}    
else if (clickedOperator == tr("ⁿ√x")) { //Если на кнопочке написано "ⁿ√x", тогда
        double operand = ui->lcd1->text().toDouble();  //Записываем в operand содержимое lcd1
        ui->lcd2->setText("ⁿ√(" + QString::number(operand) + "), задайте n");

        num = operand; //Записываем операнд в num

    }
waitingForOperand = true; //ждем следующего операнда
}


//Унарные операции
void newmadcalc::unaryOperatorClicked() {
 QPushButton *button = (QPushButton *)sender(); //Слушаем sender
 clickedOperator = button->text();              //Пишем в clickedOperator знак, прочитанный с кнопки
 double operand = ui->lcd1->text().toDouble();  //Записываем в operand содержимое lcd1
 num = operand;
 double result = 0.0;                           //объявляем переменную result, равную 0


 if (clickedOperator == tr("1/x")) { //следующая функция занимается делением единицы на операнд
  if (operand == 0.0) {
   abortOperation();
   return;
  }
  result = 1.0 / operand;
 }

//Тригонометрические функции
//Синус
 else if (clickedOperator == tr("sin")){
          if   (GradeState=="Deg") {
          if      (operand == 180) {result = 0;}
          else if (operand == 360) {result = 0;}
          else
          result = sinl(operand*Pi/180);
     }

     else if (GradeState=="Rad") {result = sinl(operand);}
     else if (GradeState=="Gon") {double Gon = operand/200*Pi; result = sinl(Gon);}
     }

//Арксинус
 else if (clickedOperator == tr("arcsin")){
     double operand = ui->lcd1->text().toDouble();  //Записываем в operand содержимое lcd1
          if (GradeState=="Deg") {
          {result = asin(operand)*(180/Pi);}
     }

     else if (GradeState=="Rad") {result = qAsin(operand);}
     else if (GradeState=="Gon") {double Gon = qAsin(operand); result = Gon*63.66197723676;} //1 радиан = 63.66197723676 града.
//Мы тут не городим всякие сложные математические конструкции, а тупо умножаем ответ, возвращаемой функцией в радианах, на
//соответствующее число. Главное, что это работает.
     }

//Косинус
 else if (clickedOperator == tr("cos")){
     double operand = ui->lcd1->text().toDouble();  //Записываем в operand содержимое lcd1
          if (GradeState=="Deg") {
          if (operand == 90) {result = 0;}
          else
          result = cosl(operand*Pi/180);
     }

     else if (GradeState=="Rad") {result = cosl(operand);}
     else if (GradeState=="Gon") {double Gon = operand/200*Pi; result = cosl(Gon);}
     }

 //Арккосинус
  else if (clickedOperator == tr("arccos")){
      double operand = ui->lcd1->text().toDouble();  //Записываем в operand содержимое lcd1
           if (GradeState=="Deg") {

           {result = acos(operand)*(180/Pi);}

      }

      else if (GradeState=="Rad") {result = qAcos(operand);}
      else if (GradeState=="Gon") {double Gon = qAcos(operand); result = Gon*63.66197723676;} //1 радиан = 63.66197723676 града.
 //Мы тут не городим всякие сложные математические конструкции, а вместо этого тупо умножаем ответ, возвращаемой функцией в радианах, на
 //соответствующее число. Главное, что это работает.
      }


//Тангенс

if (clickedOperator == tr("tg")){
          if (GradeState=="Deg") {
          result = qTan(operand*Pi/180);
     }

     else if (GradeState=="Rad") {result = qTan(operand);}
     else if (GradeState=="Gon") {double Gon = operand/200*Pi; result = qTan(Gon);}
     }

//Арктангенс
else if (clickedOperator == tr("arctg")){

          if (GradeState=="Deg") {
           result = qAtan(operand*Pi/180);
      }

      else if (GradeState=="Rad") {result = qAtan(operand);}
      else if (GradeState=="Gon") {double Gon = operand/200*Pi; result = qAtan(Gon);}
      }


//Котангенс
else if (clickedOperator == tr("ctg")){

         if (GradeState=="Deg"){
                                double Deg = operand*Pi/180; result = (1/qTan(Deg));
    }
    else if (GradeState=="Rad") {result = 1/qTan(operand);}
    else if (GradeState=="Gon") {double Gon = operand/200*Pi; result = 1/qTan(Gon);}
}
//Арккотангенс
else if (clickedOperator == tr("arcctg")){
    //Определяем единицы измерения для Градусов и и Радов, для Радиан не нужно так как они возвращаются по умолчанию
    // double Deg = operand*Pi/180;
    // double Gon = operand/200*Pi;
     if      (GradeState=="Deg")   {result = (Pi/2-qAtan(operand))*57.29577951308;} //не ебем мозг сложными формулами}
     else if (GradeState=="Rad")   {result =  Pi/2-qAtan(operand);}
     else if (GradeState=="Gon")   {result = (Pi/2-qAtan(operand))*63.66197723676;} //Аналогично
}

 //Линейный логарифм
 else if (clickedOperator == tr("ln")){
          result = qLn(operand);
}

//Экспонента
else if (clickedOperator == tr("expˣ")){
         result = qExp(operand);
}

//Возведение в квадрат
else if (clickedOperator == tr("x²")){
         result = operand*operand;
}

//Факториал
else if (clickedOperator == tr("n!")){
    result = fact(operand);
    }

 QString str = QString::number(num);
 ui->lcd2->setText(clickedOperator+"(" + str + ") =");

 ui->lcd1->setText(QString::number(result)); //Выводим result на экран
 waitingForOperand = true;
 }
//Заканчиваем с унарными операторами


//Здесь мы как обычно слушаем sender и считываем что написано на кнопках из GUI
void newmadcalc::Operator(){
    QPushButton *button = (QPushButton *)sender();
    clickedOperator = button->text(); //А затем записываем полученные значения в clickedOperator
    OperatorSender(); //И вызываем функцию OperatorSender
}

//Данная функция определяет что делать с операторами сложения/вычитания/умножения/деления
void newmadcalc::OperatorSender(){

    if (perState == true){
        QString str =QString::number(num) + "%"+clickedOperator;
        ui->lcd2->setText(str);
        num = num / 100;
        LCD2 = str;
        perState = false;

    }
    else{
        num = ui->lcd1->text().toDouble();                       //Записываем в num циферьки с lcd1
        QString string = QString::number(num);
        ui->lcd2->setText(string.append(clickedOperator));       //Приращиваем к содержимому LCD2 кликнутый оператор
        LCD2=string;
    }

    waitingForOperand = true;
}

//Возведение в степень
void newmadcalc::Exponentiation(){
    QPushButton *button = (QPushButton *)sender(); //Слушаем sender
    clickedOperator = button->text();              //Пишем в clickedOperator знак, прочитанный с кнопки
    if (clickedOperator == "xʸ"){
        ui->lcd1->setText(QString::number(num));
        ui->lcd2->setText(QString::number(num).append("^"));       //Приращиваем к содержимому LCD2 кликнутый оператор
        LCD2 = ui->lcd2->text();
    }
    waitingForOperand = true;
}

//Функция знака =
void newmadcalc::equalClicked() {
 double operand = ui->lcd1->text().toDouble(); // берем операнд c экрана
 double result;

 //Конструкция для LCD2

 QString string = QString::number(operand);  //string получает значение operand
 ui->lcd2->setText(LCD2.append(string)+"="); //append приращивает string к LCD2

 if (clickedOperator == "ⁿ√x"){
 result = qPow(num, 1/operand);
 ui->lcd1->setText(QString::number(result));
 ui->lcd2->setText("<sup>" + QString::number(operand) + "</sup>" + "√(" + QString::number(num) + ")="); //Здесь демонстрация работы с надстрочным индексом. Нижний регистр sub, верхний sup
 }
 else if (clickedOperator == "y%(x)"){
     result = num*operand/100;
     ui->lcd1->setText(QString::number(result));
     ui->lcd2->setText(QString::number(num)+ "%("+QString::number(operand)+")=");
     ui->lcd3->setText(clickedOperator);

 }
 else if (clickedOperator == "logₐx"){
     result = log(num)/log(operand);
     ui->lcd1->setText(QString::number(result));
     ui->lcd2->setText("log<sub>" + QString::number(operand) + "</sub>" + QString::number(num) + "=");
 }
 else if (clickedOperator == "xʸ"){
     result = qPow(num, operand);
     ui->lcd1->setText(QString::number(result));
     ui->lcd2->setText(LCD2 + "=");
     }
 else{
 if (!clickedOperator.isEmpty()) {
   if (!calculate(operand, clickedOperator)) {
   abortOperation();
   return;
  }
  clickedOperator.clear();
 }
 else {
  num = operand;
 }
 ui->lcd1->setText(QString::number(num));
 num= 0.0;
 }


 perState = false;
 LCD2="";
 waitingForOperand = true;
}

//функция вычислений
bool newmadcalc::calculate(double rightOperand, const QString &pendingOperator) {
 if (pendingOperator == tr("+")) num += rightOperand;
 else if (pendingOperator == tr("-")) num -= rightOperand;
 else if (pendingOperator == tr("*")) num *= rightOperand;
 else if (pendingOperator == tr("/")) {
 if      (rightOperand == 0.0)        return false;
   num /= rightOperand;
   }
  return true;
}

void newmadcalc::CE()
{
    if (waitingForOperand) return;
    ui->lcd1->setText("0");
    waitingForOperand = true;
}

void newmadcalc::ClearAll()
{
    num = 0.0; //Приравниваем предыдущий операнд к нулю
    snum = 0.0;
    clickedOperator.clear(); //Очищаем переменную, отвечающую за хранение знака оператора
    ui->lcd1->setText("0"); //Устанавливаем 0 на наш экран
    ui->lcd2->setText("");
    ui->lcd3->setText("");
    waitingForOperand = true; //Ждем следующего операнда
    ShiftState = false;
    LCD2 = "";
}


//Вызов формы с информацией о программе
void newmadcalc::About()
{
                 formAbout->show();
}

//ничего не делает, это чтобы скопипастить если вдруг понадобится
#ifdef DEBUG
void newmadcalc::on_btnCtg_clicked()
{

}
#endif
